routes/web.php
<?php

use Illuminate\Support\Facades\Route;

use App\Http\Controllers\HomeController;
use App\Http\Controllers\InventoryController;
use App\Http\Controllers\ItemController;
use App\Http\Controllers\WarehouseController;


/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "web" middleware group. Make something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});


// Authentication routes (login, register, etc.)
Auth::routes();

Route::middleware(['auth'])->group(function () {

    Route::get('/home', [HomeController::class, 'index'])->name('home');

    // Inventory routes
    Route::group(['prefix'=>'/inventory','as'=>'inventory.'], function(){
        Route::get('/', [InventoryController::class, 'index'])->name('index');
        
        Route::group(['prefix'=>'/mutations','as'=>'mutations.'], function(){
            Route::get('/index/{type}', [InventoryController::class, 'indexMutation'])->name('index');
            Route::get('/create', [InventoryController::class, 'createMutation'])->name('create');
            Route::post('/store', [InventoryController::class, 'storeMutation'])->name('store');
        });

        // Route::get('/incoming-mutations', [InventoryController::class, 'incomingMutations'])->name('mutations.create');
        // Route::post('/incoming-mutations', [InventoryController::class, 'storeIncomingMutation'])->name('mutations.create');

        // Route::get('/outgoing-mutations', [InventoryController::class, 'outgoingMutations'])->name('mutations.create');
        // Route::post('/outgoing-mutations', [InventoryController::class, 'storeOutgoingMutation'])->name('mutations.create');
        
    });

    
    /**  Master Data routes **/

    Route::group(['prefix'=>'/masterdata','as'=>'masterdata.'], function(){

        // Items routes
        Route::group(['prefix'=>'/items','as'=>'items.'], function(){
            Route::get('/', [ItemController::class, 'index'])->name('index');
            Route::get('/create', [ItemController::class, 'create'])->name('create');
            Route::post('/store', [ItemController::class, 'store'])->name('store');
        });

        // Warehouses routes
        Route::group(['prefix'=>'/warehouses','as'=>'warehouses.'], function(){
            Route::get('/', [WarehouseController::class, 'index'])->name('index');
            Route::get('/create', [WarehouseController::class, 'create'])->name('create');
            Route::post('/store', [WarehouseController::class, 'store'])->name('store');
        });

    });

});

app/Models/Mutation.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Mutation extends Model
{
    use HasFactory; 

    protected $table = 'mutations';

    protected $fillable = ['type', 'quantity', 'item_id', 'warehouse_id'];

    public function item()
    {
        return $this->belongsTo(Item::class);
    }

    public function warehouse()
    {
        return $this->belongsTo(Warehouse::class);
    }
}

app/Http/Controllers/InventoryController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Validator;
use App\Models\Item;
use App\Models\Warehouse;
use App\Models\Mutation;

class InventoryController extends Controller
{
    //
    public function __construct()
    {
        $this->middleware('auth'); // Only authenticated users can access
        // Add more middleware for authorization if needed
    }

    public function index()
    {
        //
    }

    
    public function indexMutation($type)
    {
        // Implement logic for displaying index of route /inventory

        $mutations = Mutation::where("type",$type)->get();
        return view('inventory.mutations.index', ['mutations' => $mutations, 'type' => $type]);
        
    }

    public function createMutation()
    {
        $items = Item::all();
        $warehouses = Warehouse::all();

        return view('inventory.mutations.create', compact('items', 'warehouses'));
    }

    public function storeMutation(Request $request)
    {
        $validator = $this->validateMutationRequest($request);

        if ($validator->fails()) {
            return redirect()
                ->route('mutations.create')
                ->withErrors($validator)
                ->withInput();
        }

        $mutationType = $request->input('type');

        Mutation::create([
            'type' => $mutationType,
            'quantity' => $request->input('quantity'),
            'item_id' => $request->input('item_id'),
            'warehouse_id' => $request->input('warehouse_id'),
        ]);

        return redirect()->route('inventory.mutations.index', $mutationType)->with('success', ucfirst($mutationType) . ' mutation recorded successfully.');
    }
    

    public function trackInventory()
    {
        $inventory = Mutation::with(['item', 'warehouse'])->get();

        return view('inventory.track', compact('inventory'));
    }

    private function validateMutationRequest(Request $request)
    {
        return Validator::make($request->all(), [
            'type' => 'required|in:incoming,outgoing',
            'quantity' => 'required|numeric|min:1',
            'item_id' => 'required|exists:items,id',
            'warehouse_id' => 'required|exists:warehouses,id',
        ]);
    }
}

resources/views/inventory/mutations/create.blade.php
<!-- resources/views/inventory/create_mutations.blade.php -->

@extends('layouts.app')

@section('content')

    <div class="d-flex justify-content-between">
        <h1>Create Mutation</h1>
        <a href="{{ route('inventory.index').'/' }}" class="btn btn-warning mt-2 mb-1">Back to Inventory</a>
    </div>

    @if ($errors->any())
        <div class="alert alert-danger">
            <ul>
                @foreach ($errors->all() as $error)
                    <li>{{ $error }}</li>
                @endforeach
            </ul>
        </div>
    @endif

    @if (session('success'))
        <div class="alert alert-success">
            {{ session('success') }}
        </div>
    @endif

    <form action="{{ route('inventory.mutations.store') }}" method="post">
        @csrf

        <div class="row">
            <div class="mb-3 col-6">
                <label for="type">Mutation Type:</label>
                <select name="type" id="type" class="form-control">
                    <option value="incoming">Incoming</option>
                    <option value="outgoing">Outgoing</option>
                </select>
            </div>
            <div class="mb-3 col-6">
                <label for="quantity">Quantity:</label>
                <input type="number" name="quantity" id="quantity" min="1" class="form-control" required>
            </div>
        </div>
        <div class="row">
            <div class="mb-3 col-6">
                <label for="item_id">Item:</label>
                <select name="item_id" id="item_id" class="form-control">
                    @foreach ($items as $item)
                        <option value="{{ $item->id }}">{{ $item->name }}</option>
                    @endforeach
                </select>
            </div>
            <div class="mb-3 col-6">
                <label for="warehouse_id">Warehouse:</label>
                <select name="warehouse_id" id="warehouse_id" class="form-control">
                    @foreach ($warehouses as $warehouse)
                        <option value="{{ $warehouse->id }}">{{ $warehouse->name }}</option>
                    @endforeach
                </select>
            </div>
        </div>
        <button type="submit" class="btn btn-primary">Create Mutation</button>
    </form>
@endsection

resources/views/inventory/mutations/index.blade.php
<!-- displaying incoming mutations -->

<!-- resources/views/inventory/incoming_mutations.blade.php -->

@extends('layouts.app')

@section('content')

    <div class="d-flex justify-content-between">
        <h1>{{ ucwords($type) }} Mutations</h1>
        <a href="{{ route('inventory.mutations.create') }}" class="btn btn-primary mt-2 mb-1">Create New</a>
    </div>

    @if (session('success'))
        <div class="alert alert-success">
            {{ session('success') }}
        </div>
    @endif

    <table>
        <thead>
            <tr>
                <th>Item</th>
                <th>Quantity</th>
                <th>Warehouse</th>
            </tr>
        </thead>
        <tbody>
            @foreach ($mutations as $mutation)
                <tr>
                    <td>{{ $mutation->item->name }}</td>
                    <td>{{ $mutation->quantity }}</td>
                    <td>{{ $mutation->warehouse->name }}</td>
                </tr>
            @endforeach
        </tbody>
    </table>
@endsection